package io.hmit.common.utils;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @author Eve
 * @email mengmengeve@gmail.com
 * @create 2021/3/1
 */
/**
 * 流水号生成类 ：内存保存流水号增长标记，按天重置标识位
 */
public class SerialNumberTool {

    private static SerialNumberTool serialNumberTool = null;
    private static SimpleDateFormat yMd = new SimpleDateFormat("yyyyMMdd");
    //用于自增长的标识
    private Integer flag;
    //用于记录日期
    private Date date;


    private SerialNumberTool() {
        if(date == null || !(yMd.format(new Date()).equals(yMd.format(date)))){
            date = new Date();
            flag = 1;
        }
    }

    /**
     * 判断是否改变
     */
    private  void checkChangeDay(){
        if(date == null || !(yMd.format(new Date()).equals(yMd.format(date)))){
            date = new Date();
            flag = 1;
        }
    }


    /**
     * 取得PrimaryGenerater的单例实现
     *
     * @return
     */
    public static SerialNumberTool getInstance() {
        if (serialNumberTool == null) {
            synchronized (SerialNumberTool.class) {
                if (serialNumberTool == null) {
                    serialNumberTool = new SerialNumberTool();
                }
            }
        }
        return serialNumberTool;
    }


    /**
     * 生成下一个编号,前缀自动补全 0
     * params:
     * 2.places 需要补全的总位数
     *
     */
    public synchronized String generaterNextNumber(int places) {

        checkChangeDay();
        StringBuffer stringBuffer = new StringBuffer();
        int numPlaces = flag.toString().length();
        //数字位数小于需要补全的总位数，需要补全0
        if(numPlaces < places ){
            for (int i = 0; i < places - numPlaces; i++) {
                stringBuffer.append("0");
            }
            stringBuffer.append(flag);
        }
        else stringBuffer.append(flag.toString());
        flag++;
        return stringBuffer.toString();
    }

    /**
     * 避免当断网后重连或者服务器重启时导致标识flag清0，可以手动设置flag的开始点
     * @param position
     */
    public void operateFlag(int position){
        this.flag = position;
    }
}
